RS              BIT     P3.4
R_W             BIT     P3.5
ENABLE          BIT     P3.3
DB0_DB7         DATA     P1
;************************************************************
                ORG     00H
                JMP     start
		ORG	000BH
		AJMP	INSERS
                ORG     50H
start:
                MOV	TMOD,#0
		MOV	TL0,#0
		MOV	TH0,#0
		SETB	EA
		SETB	ET0
		SETB	TR0
		MOV	R5,#50
		CLR	P3.2
		SETB	P3.1
		MOV     SP,#60H
                CALL    Initial
                CALL    CLS
                MOV     A,#10000000B            ;set the address
                CALL    Write_instruction
                MOV     DPTR,#LINE1
                CALL    PR_STRING

                MOV     A,#11000000B            ;set the address
                CALL    Write_instruction
                MOV     DPTR,#LINE2
                CALL    PR_STRING

LOOP:            JMP     LOOP
LINE1:           DB      "LCD testing-----",00H
LINE2:           DB      "Easy learning it.",00H
;INTERRUPT
INSERS:
		MOV	TH0,#0
		MOV	TL0,#0
		DJNZ	R5,NO
		MOV	R5,#50
		CPL	P3.2
		CPL	P3.1
NO:		RETI
;*****************************************************************
;InitialƵ{
;]wLCMϥ8BITS׬yơBܨBϥ5*7rBܾnܡB
;nܦ{{
;*****************************************************************
Initial:
                MOV     A,#00111000B
                CALL    Write_instruction

                MOV     A,#00001110B
                CALL    Write_instruction

                MOV     A,#00000110B
                CALL    Write_instruction
                RET
;*****************************************************************
;CheckBusyƵ{
;LCMťiHU@өRO
;*****************************************************************
CheckBusy:
                PUSH    ACC
CheckBusyLoop:
		CLR	ENABLE
		SETB	R_W
		CLR	RS
                SETB    ENABLE
                MOV     A,DB0_DB7
                CLR     ENABLE
  ;              JB      ACC.7,CheckBusyLoop
                POP     ACC
                CALL    DELAY
                RET
;*****************************************************************
;Write_instructionƵ{
;NACCƿJLCMIRȦs
;*****************************************************************
Write_instruction:
                CALL    CheckBusy
		CLR	ENABLE
		CLR	R_W
		CLR	RS
                SETB    ENABLE
                MOV     DB0_DB7,A
                CLR     ENABLE
                RET
;*****************************************************************
;WriteLCDDataƵ{
;NACCƿJLCMDRȦs
;*****************************************************************
WriteLCDData:
                CALL    CheckBusy
		CLR	ENABLE
		CLR	R_W
		SETB	RS
                SETB    ENABLE
                MOV     DB0_DB7,A
                CLR     ENABLE
                RET
;*****************************************************************
;clsƵ{
;MLCMܦr
;*****************************************************************
CLS:
                MOV     A,#01H
                CALL    Write_instruction
                RET
;*****************************************************************
;PR_STRINGƵ{
;N@ӦrܦbLCMArꪺ_l}nsJDPTRArꥲH00H
;*****************************************************************
PR_STRING:
                PUSH    ACC
PR_LOOP:
                CLR     A
                MOVC    A,@A+DPTR
                JZ      END_PR
                CALL    WriteLCDData
                INC     DPTR
                JMP     PR_LOOP
END_PR:
                POP     ACC
                RET
;*****************************************************************
;DELAYƵ{
;ɶR6*(500uS)
;*****************************************************************
DELAY:
                MOV     R6,#5
D1:             MOV     R7,#248
                DJNZ    R7,$
                DJNZ    R6,D1
                RET
;*****************************************************************
                END
