RS		BIT	P3.4H
R_W		BIT	P3.5H
ENABLE		BIT	P3.3H
DB0_DB7 	DATA	90H
;************************************************************
		ORG	00H
		JMP	start
		ORG	000BH
		AJMP	INSERS
		ORG	50H
start:
		MOV	TMOD,#0
		MOV	TL0,#0
		MOV	TH0,#0
		SETB	EA
		SETB	ET0
		SETB	TR0
		MOV	R5,#50
		CLR	P3.2
		SETB	P3.1
		MOV	SP,#60H
		CALL	Initial
		CALL	CLS
		MOV	A,#10000000B		;set the address
		CALL	Write_instruction
		MOV	DPTR,#LINE1
		CALL	PR_STRING
OUT:
		MOV	A,#11001000B		;set the address
		CALL	Write_instruction
		MOV	R0,#0
		MOV	A,P2
		CPL	A
		MOV	R2,A
OUTPUT_VALUE:
		MOV	A,R2
		JNB	ACC.7,OUTPUT_0
OUTPUT_1:
		MOV	A,#31H
		CALL	WriteLCDData
		JMP	NEXT
OUTPUT_0:
		MOV	A,#30H
		CALL	WriteLCDData
NEXT:
		INC	R0
		MOV	A,R2
		RL	A
		MOV	R2,A
		CJNE	R0,#8,OUTPUT_VALUE

		JMP	OUT
LINE1:		DB	"BIN_DAT=",00H

;INTERRUPT
INSERS:
		MOV	TL0,#0
		MOV	TH0,#0
		DJNZ	R5,NO
		MOV	R5,#50
		CPL	P3.2
		CPL	P3.1
NO:		RETI
;*****************************************************************
;InitialƵ{
;]wLCMϥ8BITS׬yơBܨBϥ5*7rBܾnܡB
;
;*****************************************************************
Initial:
		MOV	A,#00111000B
		CALL	Write_instruction
		MOV	A,#00001100B
		CALL	Write_instruction
		MOV	A,#00000110B
		CALL	Write_instruction
		RET
;*****************************************************************
;CheckBusyƵ{
;LCMťiHU@өRO
;*****************************************************************
CheckBusy:
		PUSH	ACC
CheckBusyLoop:
		CLR	RS
		SETB	R_W
		CLR	ENABLE	
		SETB	ENABLE
		MOV	A,DB0_DB7
		CLR	ENABLE
;		JB	ACC.7,CheckBusyLoop
		POP	ACC
		CALL	DELAY
		RET
;*****************************************************************
;Write_instructionƵ{
;NACCƿJLCMIRȦs
;*****************************************************************
Write_instruction:
		CALL	CheckBusy
		CLR	ENABLE
		CLR	RS
		CLR	R_W
		SETB	ENABLE
		MOV	DB0_DB7,A
		CLR	ENABLE
		RET
;*****************************************************************
;WriteLCDDataƵ{
;NACCƿJLCMDRȦs
;*****************************************************************
WriteLCDData:
		CALL	CheckBusy
		CLR	ENABLE
		SETB	RS
		CLR	R_W
		SETB	ENABLE
		MOV	DB0_DB7,A
		CLR	ENABLE
		RET
;*****************************************************************
;clsƵ{
;MLCMܦr
;*****************************************************************
CLS:
		MOV	A,#01H
		CALL	Write_instruction
		RET
;*****************************************************************
;PR_STRINGƵ{
;N@ӦrܦbLCMArꪺ_l}nsJDPTRArꥲH00H
;*****************************************************************
PR_STRING:
		PUSH	ACC
PR_LOOP:
		CLR	A
		MOVC	A,@A+DPTR
		JZ	END_PR
		CALL	WriteLCDData
		INC	DPTR
		JMP	PR_LOOP
END_PR:
		POP	ACC
		RET
;*****************************************************************
;DELAYƵ{
;ɶR6*(500uS)
;*****************************************************************
DELAY:
		MOV	R6,#5
D1:		MOV	R7,#248
		DJNZ	R7,$
		DJNZ	R6,D1
		RET
		END
