RS		BIT	P3.4
R_W		BIT	P3.5
ENABLE		BIT	P3.3
DB0_DB7 	DATA	P1
;************************************************************
		ORG	00H
		JMP	START1
		ORG	000BH
		AJMP	INSERS
		ORG	50H
START1:		MOV 	TMOD,#0
		MOV	TL0,#0
		MOV	TH0,#0
		SETB	EA
		SETB	ET0
		SETB	TR0
		MOV	R5,#50
		CLR	P3.2
		SETB	P3.1
START:
		MOV	SP,#60H
		CALL	Initial
		CALL	CLS
		CALL	SAVE_FONT
		MOV	A,#10000111B		;set the address
		CALL	Write_instruction
		MOV	R1,#0
OUT_DDRAM1:
		MOV	A,R1
		CALL	WriteLCDData
		INC	R1
		CJNE	R1,#3,OUT_DDRAM1

		MOV	A,#11000110B		;set the address
		CALL	Write_instruction
		MOV	R1,#3
OUT_DDRAM2:
		MOV	A,R1
		CALL	WriteLCDData
		INC	R1
		CJNE	R1,#8,OUT_DDRAM2
;LOOP1:		MOV	A,#00000111B
;		CALL	Write_instruction
LOOP:		JMP	LOOP
LINE1:		DB	"LCD testing-----",00H
LINE2:		DB	"Easy earning it.",00H
;*****************************************************************
;InitialƵ{
;]wLCMϥ8BITS׬yơBܨBϥ5*7rBܾnܡB
;
;*****************************************************************
Initial:
		MOV	A,#00111000B
		CALL	Write_instruction

		MOV	A,#00001100B
		CALL	Write_instruction

		MOV	A,#00000110B
		CALL	Write_instruction
		RET
;*****************************************************************
;CheckBusyƵ{
;LCMťiHU@өRO
;*****************************************************************
CheckBusy:
		PUSH	ACC
CheckBusyLoop:
		CLR	ENABLE
		SETB	R_W
		CLR	RS	
		SETB	ENABLE
		MOV	A,DB0_DB7
		CLR	ENABLE
;		JB	ACC.7,CheckBusyLoop
		POP	ACC
		CALL	DELAY
		RET
;*****************************************************************
;Write_instructionƵ{
;NACCƿJLCMIRȦs
;*****************************************************************
Write_instruction:
		CALL	CheckBusy
		CLR	ENABLE
		CLR	R_W
		CLR	RS
		SETB	ENABLE
		MOV	DB0_DB7,A
		CLR	ENABLE
		RET
;*****************************************************************
;WriteLCDDataƵ{
;NACCƿJLCMDRȦs
;*****************************************************************
WriteLCDData:
		CALL	CheckBusy
		CLR	ENABLE
		CLR	R_W
		SETB	RS
		SETB	ENABLE
		MOV	DB0_DB7,A
		CLR	ENABLE
		RET
;*****************************************************************
;clsƵ{
;MLCMܦr
;*****************************************************************
CLS:
		MOV	A,#01H
		CALL	Write_instruction
		RET
;*****************************************************************
;SAVE_FONTƵ{
;'NϥΪ̩wqbUSER_PATTERNrsJLCMCGRAM
;*****************************************************************
SAVE_FONT:
		MOV	A,#01000000B
		CALL	Write_instruction
		MOV	R4,#64
		MOV	DPTR,#USER_PATTERN
PUT_LOOP:
		CLR	A
		MOVC	A,@A+DPTR
		CALL	WriteLCDData
		INC	DPTR
		DJNZ	R4,PUT_LOOP
		MOV	A,#10000000B
		CALL	Write_instruction
		RET

USER_PATTERN:
		DB	 00H,00H,00H,00H,01H,03H,03H,00H
		DB	 04H,04H,0eH,1fH,1fH,1fH,0aH,00H
		DB	 00H,00H,00H,00H,10H,18H,18H,00H
		DB	 00H,00H,00H,17H,10H,17H,17H,00H
		DB	 07H,0aH,15H,03H,1cH,1fH,1fH,00H
		DB	 1fH,1fH,0eH,1fH,0eH,1fH,1fH,00H
		DB	 1cH,0aH,15H,1fH,07H,1fH,1fH,00H
		DB	 00H,00H,00H,1dH,01H,1dH,1dH,00H
;INTERRUPT
INSERS:
		MOV	TH0,#0
		MOV	TL0,#0
		DJNZ	R5,NO
		MOV	R5,#50
		CPL	P3.2
		CPL	P3.1
NO:		RETI
;*****************************************************************
;DELAYƵ{
;ɶR6*(500uS)
;*****************************************************************
DELAY:
		MOV	R6,#5
D1:		MOV	R7,#248
		DJNZ	R7,$
		DJNZ	R6,D1
		RET
;*****************************************************************
		END
