RS		BIT	P3.4
R_W		BIT	P3.5
ENABLE		BIT	P3.3
DB0_DB7 	DATA	P1
;************************************************************
		ORG	00H
		JMP	START1
		ORG     000BH
		AJMP	INSERS
		ORG	50H
START1:		MOV	TMOD,#0
		MOV	TL0,#0H
		MOV 	TH0,#00H
		SETB	EA
		SETB	ET0
		SETB	TR0
		MOV	R5,#50
		CLR	P3.2
		SETB	P3.1
start:
		MOV	SP,#60H
		CALL	Initial
		CALL	CLS
		CALL	SAVE_FONT
		MOV	A,#10000000B		;set the address
		CALL	Write_instruction
		MOV	DPTR,#LINE1
		CALL 	PR_STRING
		MOV 	A,#11000000B
		CALL 	Write_instruction
		MOV 	DPTR,#LINE2
		CALL 	PR_STRING
		MOV	R2,#4
		MOV 	R1,#0
TIME1:
		CALL	DELAY
		INC	R1
		CJNE	R1,#250,TIME1		
		DJNZ	R2,TIME1
		MOV	A,#10000000B		;set the address
		CALL	Write_instruction
		MOV	R1,#0
TU1:
		MOV	A,#0FFH
		CALL	WriteLCDData
		INC	R1
		CJNE	R1,#16,TU1		
		MOV	A,#11000000B		;set the address
		CALL	Write_instruction
		MOV	R1,#0
TU2:
		MOV	A,#0FFH
		CALL	WriteLCDData
		INC	R1
		CJNE	R1,#16,TU2		
		MOV	R2,#4
		MOV	R1,#0
TIME2:
		CALL	DELAY
		INC	R1
		CJNE	R1,#250,TIME2		
		DJNZ	R2,TIME2
		CALL	CLS
		MOV	R2,#4
		MOV	R1,#0
TIME3:
		CALL	DELAY
		INC	R1
		CJNE	R1,#250,TIME3		
		DJNZ	R2,TIME3
		CALL	SAVE_FONT
		MOV	A,#10000000B		;set the address
		CALL	Write_instruction
		MOV	R1,#0
OUT_DDRAM1:
		CLR	A
		CALL	WriteLCDData
		INC 	R1
		CJNE	R1,#16,OUT_DDRAM1
		MOV	A,#11000000B		;set the address
		CALL	Write_instruction
		MOV	R1,#0
OUT_DDRAM2:
		CLR	A
		CALL	WriteLCDData
		INC	R1
		CJNE	R1,#16,OUT_DDRAM2
		MOV	R2,#4
		MOV	R1,#0
TIME4:
		CALL	DELAY
		INC	R1
		CJNE	R1,#250,TIME4		
		DJNZ	R2,TIME4
		MOV	A,#10000000B		;set the address
		CALL	Write_instruction
		MOV	DPTR,#LINE3
		CALL 	PR_STRING
		MOV 	A,#11000000B
		CALL 	Write_instruction
		MOV 	DPTR,#LINE4
		CALL 	PR_STRING
		MOV	R2,#4
		MOV	R1,#0
TIME5:
		CALL	DELAY
		INC	R1
		CJNE	R1,#250,TIME5		
		DJNZ	R2,TIME5
LOOP:		LJMP	start
LINE1:		DB	"LCD testing-----",00H
LINE2:		DB	"Easy Learning it.",00H
LINE3:		DB	"ABCDEFGHIJKLMNOP",00H
LINE4:		DB	"0123456789abcdef",00H
Q****************************************************************
Q**			WRITE STRING Ƶ{			**
Q**			DPTR  STRING a}			**
Q****************************************************************
PR_STRING:
		PUSH 	ACC
PR_LOOP:	CLR 	A
		MOVC 	A,@A+DPTR
		JZ	END_PR
		CALL	WriteLCDData
		INC 	DPTR
		JMP	PR_LOOP
END_PR:
		POP 	ACC
		RET
; ****************************************************************
Q**	_Ƶ{----0O4 							**
Q****************************************************************
INSERS:
		MOV 	TH0,#00H
		MOV	TL0,#0H
		DJNZ	R5,NO
		MOV	R5,#50
		CPL	P3.2
		CPL	P3.1
NO:		RETI
;*****************************************************************
;InitialƵ{
;]wLCMϥ8BITS׬yơBܨBϥ5*7rBܾnܡB
;
;*****************************************************************
Initial:
		MOV	A,#00111000B
		CALL	Write_instruction

		MOV	A,#00001100B
		CALL	Write_instruction

		MOV	A,#00000110B
		CALL	Write_instruction
		RET
;*****************************************************************
;CheckBusyƵ{
;LCMťiHU@өRO
;*****************************************************************
CheckBusy:
		PUSH	ACC
CheckBusyLoop:
		CLR 	ENABLE
		SETB	R_W
		CLR	RS
		SETB	ENABLE
		MOV	A,DB0_DB7
		CLR	ENABLE
;		JB	ACC.7,CheckBusyLoop
		POP	ACC
		CALL	DELAY
		RET
;*****************************************************************
;Write_instructionƵ{
;NACCƿJLCMIRȦs
;*****************************************************************
Write_instruction:
		CALL	CheckBusy
		CLR	ENABLE
		CLR 	R_W
		CLR	RS
		SETB	ENABLE
		MOV	DB0_DB7,A
		CLR	ENABLE
		RET
;*****************************************************************
;WriteLCDDataƵ{
;NACCƿJLCMDRȦs
;*****************************************************************
WriteLCDData:
		CALL	CheckBusy
		CLR	ENABLE
		CLR	R_W
		SETB	RS
		SETB	ENABLE
		MOV	DB0_DB7,A
		CLR	ENABLE
		RET
;*****************************************************************
;clsƵ{
;MLCMܦr
;*****************************************************************
CLS:
		MOV	A,#01H
		CALL	Write_instruction
		RET
;*****************************************************************
;SAVE_FONTƵ{
;'NϥΪ̩wqbUSER_PATTERNrsJLCMCGRAM
;*****************************************************************
SAVE_FONT:
		MOV	A,#01000000B
		CALL	Write_instruction
		MOV	R4,#8
		MOV	DPTR,#USER_PATTERN
PUT_LOOP:
		CLR	A
		MOVC	A,@A+DPTR
		CALL	WriteLCDData
		INC	DPTR
		DJNZ	R4,PUT_LOOP
		MOV	A,#10000000B
		CALL	Write_instruction
		RET

USER_PATTERN:
		DB	 55H,0aaH,55H,0aaH,55H,0aaH,55H,0aaH
;*****************************************************************
;DELAYƵ{
;ɶR6*(500uS)
;*****************************************************************
DELAY:
		MOV	R6,#5
D1:		MOV	R7,#248
		DJNZ	R7,$
		DJNZ	R6,D1
		RET
		END